----------------------------------
-- New, faster version of boxes --
----------------------------------
include graphics.e -- get color names
include image.e    -- for get/save text image

constant TL = 1, HL = 2, TR = 3, VL = 4, BL = 5, BR = 6,
         DBL = 1, SGL = 2, DH = 3, DV = 4
sequence Lines, Shadow
         
Lines = {{'','','','','',''},
         {'','','','','',''},
         {'','','','','',''},
         {'','','','','',''}}

Shadow = {'','',''}  -- 3 different shadow backgrounds

global procedure box(integer style, integer row, integer col,
                     integer x, integer y,
                     integer bkgnd,integer fgnd,
                     integer shadow)
sequence topline, botline, midline, rshad, bshad
 bk_color(bkgnd)
 text_color(fgnd)
 cursor(NO_CURSOR) 
 rshad = save_text_image({row+1,col+x+2},{row+y+1,col+x+2})
 bshad = save_text_image({row+y+1,col+1},{row+y+1,col+x+1})     
 topline = Lines[style][TL] & repeat(Lines[style][HL],x) & Lines[style][TR]
 botline = Lines[style][BL] & repeat(Lines[style][HL],x) & Lines[style][BR]
 midline = Lines[style][VL] & repeat(' ',x) & Lines[style][VL]
 position(row,col)
 puts(1,topline)  
 for i = 1 to y do
   position(row+i,col)
   puts(1,midline)  
 end for          
 position(row + y,col)
 puts(1,botline)  
 if shadow then  
    position(20,1)
    for i = 1 to length(rshad) do
        rshad[i][2] = rshad[i][2] / 16
        rshad[i][1] = Shadow[shadow]
    end for  
    for i = 2 to length(bshad[1]) by 2 do
        bshad[1][i] = bshad[1][i] / 16
        bshad[1][i-1] = Shadow[shadow]
    end for
    display_text_image({row+1,col+x+2},rshad)
    display_text_image({row+y+1,col+1},bshad)
 end if   
end procedure 
                        
bk_color(GREEN)
clear_screen()                        
box(DV,4,4,52,12,BLUE,WHITE,2)

